var df_zeilen=new Array();
var df_werte=new Array();
var filesystems="hfs";

function setup() {
  if (window.widget) 
    filesystems=widget.preferenceForKey("filesystems");
  getData();
  document.getElementById("hfs").checked=filesystems.match(/hfs/);
  document.getElementById("ufs").checked=filesystems.match(/ufs/);
  document.getElementById("cd").checked=filesystems.match(/cd9660/);
  document.getElementById("smb").checked=filesystems.match(/smbfs/);
}


function getData() {
  
  //  var o='<table><tr><td></td><td id="table_head">50%</td></tr>'; // Output
  
  var o='<div>';
  if (window.widget) {
    var df_out = widget.system("/bin/df -T"+filesystems, null).outputString;
  } else {
    var df_out=
"Filesystem    512-blocks     Used    Avail Capacity  Mounted on\n" +
"/dev/disk0s10  116936960 73593120 42831840    63%    /\n"+
"/dev/disk2         61440    47440    14000    77%    /Volumes/GraphicConverter X";
  }
  df_zeilen = df_out.split("\n");
  for (i=1; i < df_zeilen.length; i++) {
    df_werte = df_zeilen[i].split(/\s+/);
    var percent = parseInt(df_werte[4]);
    var mountpt = cutoff(df_werte.slice(5).join(" "));
    if (percent && mountpt) {
      var color;
      if (percent < 50) {
        color="green";
      } else if (percent < 80) {
        color ="yellow";
      } else {
        color="red";
      }
      o += "<div class='line'><div class='left'>"+
	mountpt+
	"</div><div class='right' style='width:"+percent+
	"px;background-color:"+color+";'>"+percent+"%</div></div>";
    }
  }
  o += "</div>";
  document.getElementById("main").innerHTML=o;
  window.resizeTo(250,15*(Math.max(5,df_zeilen.length)));
}

function setPrefs(e) {
  var f = new Array;
  if (document.getElementById("hfs").checked) 
    f.push("hfs");
  if (document.getElementById("ufs").checked) 
    f.push("ufs");
  if (document.getElementById("cd").checked) 
    f.push("cd9660");
  if (document.getElementById("smb").checked) 
    f.push("smbfs");
  filesystems=f.join(",");
  if (window.widget) 
    widget.setPreferenceForKey(filesystems,"filesystems");
}

function cutoff(s) {
  if (!s) return null;
  var l=s.length;
  if (l < 22) {
    return s;
  } else {
    return "... "+s.substr(-18,18);
  }
}

var timer     = null;
var flipShown = false;
var animation = {
  duration:0, 
  starttime:0, 
  to:0.5, 
  now:0.0, 
  from:0.0, 
  element:null, 
  timer:null
};

function limit_3 (a, b, c) {
  return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
  return from + (to - from) * ease;
}

function animate() {
  var T;
  var ease;
  var time = (new Date).getTime();

  T = limit_3(time-animation.starttime, 0, animation.duration);
  if (T >= animation.duration) {
    clearInterval (animation.timer);
    animation.timer = null;
    animation.now = animation.to;
  } else {
    ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
    animation.now = computeNextFloat (animation.from, animation.to, ease);
  }
  animation.element.style.opacity = animation.now;
}

function mouseMove(event) {

  if (!flipShown) {
    // Fade in the flip widget
    if (animation.timer != null) {
	clearInterval (animation.timer);
	animation.timer  = null;
    }

    var starttime = (new Date).getTime() - 13; // set it back one frame
    
    animation.duration = 500;
    animation.starttime = starttime;
    animation.element = document.getElementById ('flip');
    animation.timer = setInterval ("animate();", 13);
    animation.from = animation.now;
    animation.to = 0.5;
    animate();
    flipShown = true;
  }
}

function mouseExit(event) {
  if (flipShown) {
    // Fade out the flip widget
    if (animation.timer != null) {
	clearInterval (animation.timer);
	animation.timer  = null;
    }

    var starttime = (new Date).getTime() - 13; // set it back one frame
    
    animation.duration = 500;
    animation.starttime = starttime;
    animation.element = document.getElementById ('flip');
    animation.timer = setInterval ("animate();", 13);
    animation.from = animation.now;
    animation.to = 0.0;
    animate();
    flipShown = false;
  }
}  

function enterFlip(event) {
  document.getElementById("fliprollie").style.display="block";
}

function exitFlip(event) {
  document.getElementById("fliprollie").style.display="none";
}

function showBack(event) {
  var front = document.getElementById("front");
  var back = document.getElementById("back");

  if (window.widget)
    widget.prepareForTransition("ToBack");
  front.style.display="none";
  back.style.display="block";

  if (window.widget)
    setTimeout ('widget.performTransition();', 0);
}

function hideBack(event) {
  var front = document.getElementById("front");
  var back = document.getElementById("back");

  if (window.widget)
    widget.prepareForTransition("ToFront");
  
  front.style.display="block";
  back.style.display="none";
  
  if (window.widget)    
    setTimeout ('widget.performTransition();', 0);  
}

